    <script lang="ts" setup>
        import {definePageMeta} from "../../.nuxt/imports";
        import { useRoute } from "vue-router";
        import {useErrorStore} from "../../stores/useErrorStore";
        import {navigateTo} from "nuxt/app";
        definePageMeta({
            middleware: ['auth']
        })

        // @todo titre des pages

        const route = useRoute();

        const id = route.params.id
        const errorStore = useErrorStore();

        const star = ref<Star|null>(id ? null : { name: '', firstName: '', image: null, description: null })

        const imageUrl = ref<string | null>(null);

        async function loadData(){
            if (id) {
                const { data, error } = await useCustomFetch<ApiResponse<Star>>(`/api/stars/${id}`)
                if (error.value || !data.value.success) {
                    errorStore.setError(data.value.message || 'An unknown error occurred');
                } else {
                    errorStore.clearError();
                }
                if(data.value.data){
                    star.value = data.value.data as Star
                    if(star.value && star.value.imageUrl){
                        imageUrl.value = star.value.imageUrl
                    }
                }
            }
        }
        loadData();
        const selectedFile = ref<File | null>(null);
        async function handleSave() {
            if (star.value) {
                if (selectedFile.value && !['image/jpeg', 'image/png', 'image/gif'].includes(selectedFile.value.type)) {
                    console.error('Le fichier sélectionné n\'est pas une image valide.');
                    return;
                }
                const formData = new FormData();
                formData.append('name', star.value.name);
                formData.append('firstName', star.value.firstName);
                if(star.value.description){
                    formData.append('description', star.value.description);
                }
                if (selectedFile.value) {
                    formData.append('image', selectedFile.value);
                }
                const url = star.value.id ? `/api/stars/${star.value.id}` : '/api/stars'
                //Use the 'post' method even when editing a star to avoid an issue with put and multipart/form-data
                // I was encountering an error where 'name/firstName', etc., were null on the API side despite being sent correctly.
                try {
                    const { data, error } = await useCustomFetch<Star>(url, { method: 'post', body: formData, headers: {
                            'Accept': 'application/json',
                        }})
                    if (error.value || !data.value.success) {
                        errorStore.setError(data.value.message || 'An unknown error occurred');
                    } else {
                        errorStore.clearError();
                        if(!star.value.id){
                            navigateTo('/admin')
                        }
                    }
                } catch(error){
                    if (error) {
                        errorStore.setError(error || 'An error occurred');
                    }
                }
            }
        }

        const isDeletingImage = ref<boolean>(false)

        function handleFileChange(event: Event) {
            const target = event.target as HTMLInputElement;
            if (target.files) {
                const reader = new FileReader();
                reader.onload = (e) => {
                    imageUrl.value = e.target?.result as string;
                };
                reader.readAsDataURL(target.files[0]);
                selectedFile.value = target.files[0];
            }

        }

        function handleDeleteImage(){
            selectedFile.value = null;
            imageUrl.value = null;
            star.value.imageUrl = null;
            isDeletingImage.value = null;
        }
    </script>

<template>
  <div>
    <NuxtLink to="/admin" class="button inline-flex">
        <svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-6 h-6 mr-2">
            <path stroke-linecap="round" stroke-linejoin="round" d="m11.25 9-3 3m0 0 3 3m-3-3h7.5M21 12a9 9 0 1 1-18 0 9 9 0 0 1 18 0Z" />
        </svg>
        Back to list
    </NuxtLink>
    <h1 class="text-xl font-bold mt-4 mb-4">
      <span v-if="id">Editing element with ID: {{ id }}</span><span v-else>Creating a new element</span>
    </h1>
    <form
      v-if="star"
      enctype="multipart/form-data"
      @submit.prevent="handleSave"
    >
      <div class="flex justify-between">
          <div class="w-1/2">
              <label class="block mb-2">Name</label>
              <input
                  v-model="star.name"
                  type="string"
                  placeholder="Name"
                  class="block w-11/12 border p-1 rounded-sm"
              >
          </div>
          <div class="w-1/2">
              <label class="block mb-2">Firstname</label>
              <input
                  v-model="star.firstName"
                  type="string"
                  placeholder="Firstname"
                  class="block w-11/12 border p-1 rounded-sm"
              >
          </div>
      </div>
      <label class="block mb-2 mt-4">Description</label>
      <textarea v-model="star.description" class="block w-full border p-1 rounded-sm" rows="10"/>
      <label class="block cursor-pointer">
        <input
          type="file"
          class="hidden"
          @change="handleFileChange"
        >
        <div class="relative mt-4 mb-2">
          <img
            :src="imageUrl || '/default.jpeg'"
            alt="Uploaded image"
            class="w-auto h-48 object-cover"
          >
          <div
            v-if="!imageUrl"
            class="absolute top-0 left-0 right-0 bottom-0 flex items-center justify-center bg-black bg-opacity-50 text-white"
          >
            <span>Upload your image here</span>
          </div>
          <div
            v-if="imageUrl"
            class="absolute bottom-0 left-0 bg-red-600 text-white p-1"
            @click.prevent.stop="isDeletingImage = true"
          >
            Delete image
          </div>
        </div>
      </label>
        <div v-if="isDeletingImage" class="bg-stone-300 px-4 py-2 w-1/2 mb-2">
            Are you sure ?
            <div class="flex justify-between">
                <div @click="handleDeleteImage" class="button small delete">
                    Yes
                </div>
                <div @click.stop="isDeletingImage = false" class="button small">
                    No
                </div>
            </div>
        </div>
      <p>Image 2MO max</p>
      <button type="submit" class="button mt-2">
        Submit
      </button>
    </form>
  </div>
</template>

    <style scoped></style>
